Index: uspace/drv/hid/usbhid/usbhid.c
===================================================================
--- uspace/drv/hid/usbhid/usbhid.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/hid/usbhid/usbhid.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -134,5 +134,5 @@
 	usb_hid_report_path_t *usage_path = usb_hid_report_path();
 	if (usage_path == NULL) {
-		usb_log_debug("Failed to create usage path.\n");
+		usb_log_debug("Failed to create usage path.");
 		return false;
 	}
@@ -143,5 +143,5 @@
 		    mapping->usage_path[i].usage_page,
 		    mapping->usage_path[i].usage) != EOK) {
-			usb_log_debug("Failed to append to usage path.\n");
+			usb_log_debug("Failed to append to usage path.");
 			usb_hid_report_path_free(usage_path);
 			return false;
@@ -149,5 +149,5 @@
 	}
 
-	usb_log_debug("Compare flags: %d\n", mapping->compare);
+	usb_log_debug("Compare flags: %d", mapping->compare);
 
 	bool matches = false;
@@ -155,5 +155,5 @@
 
 	do {
-		usb_log_debug("Trying report id %u\n", report_id);
+		usb_log_debug("Trying report id %u", report_id);
 		if (report_id != 0) {
 			usb_hid_report_path_set_report_id(usage_path,
@@ -166,5 +166,5 @@
 		        USB_HID_REPORT_TYPE_INPUT);
 
-		usb_log_debug("Field: %p\n", field);
+		usb_log_debug("Field: %p", field);
 
 		if (field != NULL) {
@@ -243,5 +243,5 @@
 			    mapping->product_id);
 			if (usb_hid_ids_match(hid_dev, mapping)) {
-				usb_log_debug("IDs matched.\n");
+				usb_log_debug("IDs matched.");
 				matched = true;
 			}
@@ -250,5 +250,5 @@
 		/* Check usage match. */
 		if (mapping->usage_path != NULL) {
-			usb_log_debug("Comparing device against usage path.\n");
+			usb_log_debug("Comparing device against usage path.");
 			if (usb_hid_path_matches(hid_dev, mapping)) {
 				/* Does not matter if IDs were matched. */
@@ -258,5 +258,5 @@
 
 		if (matched) {
-			usb_log_debug("Subdriver matched.\n");
+			usb_log_debug("Subdriver matched.");
 			subdrivers[count++] = &mapping->subdriver;
 		}
@@ -285,5 +285,5 @@
 		    usb_device_get_mapped_ep_desc(dev, endpoints[i].desc);
 		if (epm && epm->present) {
-			usb_log_debug("Found: %s.\n", endpoints[i].description);
+			usb_log_debug("Found: %s.", endpoints[i].description);
 			hid_dev->poll_pipe_mapping = epm;
 			return EOK;
@@ -301,16 +301,16 @@
 
 	do {
-		usb_log_debug("Getting size of the report.\n");
+		usb_log_debug("Getting size of the report.");
 		const size_t size =
 		    usb_hid_report_byte_size(&hid_dev->report, report_id,
 		        USB_HID_REPORT_TYPE_INPUT);
-		usb_log_debug("Report ID: %u, size: %zu\n", report_id, size);
+		usb_log_debug("Report ID: %u, size: %zu", report_id, size);
 		max_size = (size > max_size) ? size : max_size;
-		usb_log_debug("Getting next report ID\n");
+		usb_log_debug("Getting next report ID");
 		report_id = usb_hid_get_next_report_id(&hid_dev->report,
 		    report_id, USB_HID_REPORT_TYPE_INPUT);
 	} while (report_id != 0);
 
-	usb_log_debug("Max size of input report: %zu\n", max_size);
+	usb_log_debug("Max size of input report: %zu", max_size);
 
 	assert(hid_dev->input_report == NULL);
@@ -323,4 +323,76 @@
 
 	return EOK;
+}
+
+static bool usb_hid_polling_callback(usb_device_t *dev, uint8_t *buffer,
+    size_t buffer_size, void *arg)
+{
+	if (dev == NULL || arg == NULL || buffer == NULL) {
+		usb_log_error("Missing arguments to polling callback.");
+		return false;
+	}
+	usb_hid_dev_t *hid_dev = arg;
+
+	assert(hid_dev->input_report != NULL);
+
+	usb_log_debug("New data [%zu/%zu]: %s", buffer_size,
+	    hid_dev->max_input_report_size,
+	    usb_debug_str_buffer(buffer, buffer_size, 0));
+
+	if (hid_dev->max_input_report_size >= buffer_size) {
+		/*! @todo This should probably be atomic. */
+		memcpy(hid_dev->input_report, buffer, buffer_size);
+		hid_dev->input_report_size = buffer_size;
+		usb_hid_new_report(hid_dev);
+	}
+
+	/* Parse the input report */
+	const int rc = usb_hid_parse_report(
+	    &hid_dev->report, buffer, buffer_size, &hid_dev->report_id);
+	if (rc != EOK) {
+		usb_log_warning("Failure in usb_hid_parse_report():"
+		    "%s\n", str_error(rc));
+	}
+
+	bool cont = false;
+	/* Continue if at least one of the subdrivers want to continue */
+	for (unsigned i = 0; i < hid_dev->subdriver_count; ++i) {
+		if (hid_dev->subdrivers[i].poll != NULL) {
+			cont = cont || hid_dev->subdrivers[i].poll(
+			    hid_dev, hid_dev->subdrivers[i].data);
+		}
+	}
+
+	return cont;
+}
+
+static bool usb_hid_polling_error_callback(usb_device_t *dev, int err_code, void *arg)
+{
+	assert(dev);
+	assert(arg);
+	usb_hid_dev_t *hid_dev = arg;
+
+	usb_log_error("Device %s polling error: %s", usb_device_get_name(dev),
+	    str_error(err_code));
+
+	/* Continue polling until the device is about to be removed. */
+	return hid_dev->running;
+}
+
+static void usb_hid_polling_ended_callback(usb_device_t *dev, bool reason, void *arg)
+{
+	assert(dev);
+	assert(arg);
+
+	usb_hid_dev_t *hid_dev = arg;
+
+	for (unsigned i = 0; i < hid_dev->subdriver_count; ++i) {
+		if (hid_dev->subdrivers[i].poll_end != NULL) {
+			hid_dev->subdrivers[i].poll_end(
+			    hid_dev, hid_dev->subdrivers[i].data, reason);
+		}
+	}
+
+	hid_dev->running = false;
 }
 
@@ -332,8 +404,8 @@
  * During initialization, the keyboard is switched into boot protocol, the idle
  * rate is set to 0 (infinity), resulting in the keyboard only reporting event
- * when a key is pressed or released. Finally, the LED lights are turned on 
+ * when a key is pressed or released. Finally, the LED lights are turned on
  * according to the default setup of lock keys.
  *
- * @note By default, the keyboards is initialized with Num Lock turned on and 
+ * @note By default, the keyboards is initialized with Num Lock turned on and
  *       other locks turned off.
  *
@@ -347,5 +419,5 @@
 	assert(dev);
 
-	usb_log_debug("Initializing HID structure...\n");
+	usb_log_debug("Initializing HID structure...");
 
 	usb_hid_report_init(&hid_dev->report);
@@ -369,10 +441,10 @@
 		usb_hid_find_subdrivers(hid_dev);
 	} else {
-		usb_log_error("Failed to parse report descriptor: fallback.\n");
+		usb_log_error("Failed to parse report descriptor: fallback.");
 		hid_dev->subdrivers = NULL;
 		hid_dev->subdriver_count = 0;
 	}
 
-	usb_log_debug("Subdriver count(before trying boot protocol): %d\n",
+	usb_log_debug("Subdriver count(before trying boot protocol): %d",
 	    hid_dev->subdriver_count);
 
@@ -385,5 +457,5 @@
 		switch (hid_dev->poll_pipe_mapping->interface->interface_protocol) {
 		case USB_HID_PROTOCOL_KEYBOARD:
-			usb_log_info("Falling back to kbd boot protocol.\n");
+			usb_log_info("Falling back to kbd boot protocol.");
 			rc = usb_kbd_set_boot_protocol(hid_dev);
 			if (rc == EOK) {
@@ -392,5 +464,5 @@
 			break;
 		case USB_HID_PROTOCOL_MOUSE:
-			usb_log_info("Falling back to mouse boot protocol.\n");
+			usb_log_info("Falling back to mouse boot protocol.");
 			rc = usb_mouse_set_boot_protocol(hid_dev);
 			if (rc == EOK) {
@@ -399,10 +471,10 @@
 			break;
 		default:
-			usb_log_info("Falling back to generic HID driver.\n");
+			usb_log_info("Falling back to generic HID driver.");
 			usb_hid_set_generic_hid_subdriver(hid_dev);
 		}
 	}
 
-	usb_log_debug("Subdriver count(after trying boot protocol): %d\n",
+	usb_log_debug("Subdriver count(after trying boot protocol): %d",
 	    hid_dev->subdriver_count);
 
@@ -419,5 +491,5 @@
 	for (unsigned i = 0; i < hid_dev->subdriver_count; ++i) {
 		if (hid_dev->subdrivers[i].init != NULL) {
-			usb_log_debug("Initializing subdriver %d.\n",i);
+			usb_log_debug("Initializing subdriver %d.",i);
 			const errno_t pret = hid_dev->subdrivers[i].init(hid_dev,
 			    &hid_dev->subdrivers[i].data);
@@ -442,69 +514,25 @@
 		rc = usb_hid_init_report(hid_dev);
 		if (rc != EOK) {
-			usb_log_error("Failed to initialize input report buffer"
-			    ".\n");
-		}
+			usb_log_error("Failed to initialize input report buffer: %s", str_error(rc));
+			// FIXME: What happens now?
+		}
+
+		usb_polling_t *polling = &hid_dev->polling;
+		if ((rc = usb_polling_init(polling))) {
+			usb_log_error("Failed to initialize polling: %s", str_error(rc));
+			// FIXME: What happens now?
+		}
+
+		polling->device = hid_dev->usb_dev;
+		polling->ep_mapping = hid_dev->poll_pipe_mapping;
+		polling->request_size = hid_dev->poll_pipe_mapping->pipe.desc.max_transfer_size;
+		polling->buffer = malloc(polling->request_size);
+		polling->on_data = usb_hid_polling_callback;
+		polling->on_polling_end = usb_hid_polling_ended_callback;
+		polling->on_error = usb_hid_polling_error_callback;
+		polling->arg = hid_dev;
 	}
 
 	return rc;
-}
-
-bool usb_hid_polling_callback(usb_device_t *dev, uint8_t *buffer,
-    size_t buffer_size, void *arg)
-{
-	if (dev == NULL || arg == NULL || buffer == NULL) {
-		usb_log_error("Missing arguments to polling callback.\n");
-		return false;
-	}
-	usb_hid_dev_t *hid_dev = arg;
-
-	assert(hid_dev->input_report != NULL);
-
-	usb_log_debug("New data [%zu/%zu]: %s\n", buffer_size,
-	    hid_dev->max_input_report_size,
-	    usb_debug_str_buffer(buffer, buffer_size, 0));
-
-	if (hid_dev->max_input_report_size >= buffer_size) {
-		/*! @todo This should probably be atomic. */
-		memcpy(hid_dev->input_report, buffer, buffer_size);
-		hid_dev->input_report_size = buffer_size;
-		usb_hid_new_report(hid_dev);
-	}
-
-	/* Parse the input report */
-	const errno_t rc = usb_hid_parse_report(
-	    &hid_dev->report, buffer, buffer_size, &hid_dev->report_id);
-	if (rc != EOK) {
-		usb_log_warning("Failure in usb_hid_parse_report():"
-		    "%s\n", str_error(rc));
-	}
-
-	bool cont = false;
-	/* Continue if at least one of the subdrivers want to continue */
-	for (unsigned i = 0; i < hid_dev->subdriver_count; ++i) {
-		if (hid_dev->subdrivers[i].poll != NULL) {
-			cont = cont || hid_dev->subdrivers[i].poll(
-			    hid_dev, hid_dev->subdrivers[i].data);
-		}
-	}
-
-	return cont;
-}
-
-void usb_hid_polling_ended_callback(usb_device_t *dev, bool reason, void *arg)
-{
-	assert(dev);
-	assert(arg);
-
-	usb_hid_dev_t *hid_dev = arg;
-
-	for (unsigned i = 0; i < hid_dev->subdriver_count; ++i) {
-		if (hid_dev->subdrivers[i].poll_end != NULL) {
-			hid_dev->subdrivers[i].poll_end(
-			    hid_dev, hid_dev->subdrivers[i].data, reason);
-		}
-	}
-
-	hid_dev->running = false;
 }
 
@@ -524,6 +552,8 @@
 	assert(hid_dev->subdrivers != NULL || hid_dev->subdriver_count == 0);
 
-
-	usb_log_debug("Subdrivers: %p, subdriver count: %d\n", 
+	free(hid_dev->polling.buffer);
+	usb_polling_fini(&hid_dev->polling);
+
+	usb_log_debug("Subdrivers: %p, subdriver count: %d",
 	    hid_dev->subdrivers, hid_dev->subdriver_count);
 
@@ -541,5 +571,4 @@
 	/* Destroy the parser */
 	usb_hid_report_deinit(&hid_dev->report);
-
 }
 
Index: uspace/drv/hid/usbhid/usbhid.h
===================================================================
--- uspace/drv/hid/usbhid/usbhid.h	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/hid/usbhid/usbhid.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -43,4 +43,5 @@
 #include <usb/dev/pipes.h>
 #include <usb/dev/driver.h>
+#include <usb/dev/poll.h>
 #include <usb/hid/hid.h>
 #include <stdbool.h>
@@ -106,4 +107,7 @@
 	usb_endpoint_mapping_t *poll_pipe_mapping;
 
+	/** Device polling structure. */
+	usb_polling_t polling;
+
 	/** Subdrivers. */
 	usb_hid_subdriver_t *subdrivers;
@@ -138,9 +142,4 @@
 void usb_hid_deinit(usb_hid_dev_t *hid_dev);
 
-bool usb_hid_polling_callback(usb_device_t *dev,
-    uint8_t *buffer, size_t buffer_size, void *arg);
-
-void usb_hid_polling_ended_callback(usb_device_t *dev, bool reason, void *arg);
-
 void usb_hid_new_report(usb_hid_dev_t *hid_dev);
 
Index: uspace/drv/nic/ar9271/ar9271.c
===================================================================
--- uspace/drv/nic/ar9271/ar9271.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/nic/ar9271/ar9271.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -666,5 +666,5 @@
 }
 
-static errno_t ar9271_init(ar9271_t *ar9271, usb_device_t *usb_device)
+static errno_t ar9271_init(ar9271_t *ar9271, usb_device_t *usb_device, const usb_endpoint_description_t **endpoints)
 {
 	ar9271->starting_up = true;
@@ -680,5 +680,5 @@
 	}
 	
-	errno_t rc = ath_usb_init(ar9271->ath_device, usb_device);
+	errno_t rc = ath_usb_init(ar9271->ath_device, usb_device, endpoints);
 	if (rc != EOK) {
 		free(ar9271->ath_device);
@@ -851,5 +851,5 @@
 	ar9271->ddf_dev = dev;
 	
-	rc = ar9271_init(ar9271, usb_device_get(dev));
+	rc = ar9271_init(ar9271, usb_device_get(dev), endpoints);
 	if (rc != EOK) {
 		free(ar9271);
Index: uspace/drv/nic/ar9271/ath_usb.c
===================================================================
--- uspace/drv/nic/ar9271/ath_usb.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/nic/ar9271/ath_usb.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -59,5 +59,5 @@
  *
  */
-errno_t ath_usb_init(ath_t *ath, usb_device_t *usb_device)
+errno_t ath_usb_init(ath_t *ath, usb_device_t *usb_device, const usb_endpoint_description_t **endpoints)
 {
 	ath_usb_t *ath_usb = malloc(sizeof(ath_usb_t));
@@ -70,9 +70,22 @@
 	ath_usb->usb_device = usb_device;
 	
-	/* TODO: Assign by iterating over pipes. */
-	ath_usb->output_data_pipe_number = 0;
-	ath_usb->input_data_pipe_number = 1;
-	ath_usb->input_ctrl_pipe_number = 2;
-	ath_usb->output_ctrl_pipe_number = 3;
+	int rc;
+
+#define _MAP_EP(target, ep_no) do {\
+	usb_endpoint_mapping_t *epm = usb_device_get_mapped_ep_desc(usb_device, endpoints[ep_no]);\
+	if (!epm || !epm->present) {\
+		usb_log_error("Failed to map endpoint: " #ep_no ".");\
+		rc = ENOENT;\
+		goto err_ath_usb;\
+	}\
+	target = &epm->pipe;\
+	} while (0);
+
+	_MAP_EP(ath_usb->output_data_pipe, 0);
+	_MAP_EP(ath_usb->input_data_pipe, 1);
+	_MAP_EP(ath_usb->input_ctrl_pipe, 2);
+	_MAP_EP(ath_usb->output_ctrl_pipe, 3);
+
+#undef _MAP_EP
 	
 	ath->ctrl_response_length = 64;
@@ -83,4 +96,7 @@
 	
 	return EOK;
+err_ath_usb:
+	free(ath_usb);
+	return rc;
 }
 
@@ -98,8 +114,5 @@
 {
 	ath_usb_t *ath_usb = (ath_usb_t *) ath->specific_data;
-	usb_pipe_t *pipe = &usb_device_get_mapped_ep(
-	    ath_usb->usb_device, ath_usb->output_ctrl_pipe_number)->pipe;
-	
-	return usb_pipe_write(pipe, buffer, buffer_size);
+	return usb_pipe_write(ath_usb->output_ctrl_pipe, buffer, buffer_size);
 }
 
@@ -118,8 +131,5 @@
 {
 	ath_usb_t *ath_usb = (ath_usb_t *) ath->specific_data;
-	usb_pipe_t *pipe = &usb_device_get_mapped_ep(
-	    ath_usb->usb_device, ath_usb->input_ctrl_pipe_number)->pipe;
-	
-	return usb_pipe_read(pipe, buffer, buffer_size, transferred_size);
+	return usb_pipe_read(ath_usb->input_ctrl_pipe, buffer, buffer_size, transferred_size);
 }
 
@@ -148,9 +158,6 @@
 	
 	ath_usb_t *ath_usb = (ath_usb_t *) ath->specific_data;
-	usb_pipe_t *pipe = &usb_device_get_mapped_ep(
-	    ath_usb->usb_device, ath_usb->output_data_pipe_number)->pipe;
-	
-	errno_t ret_val = usb_pipe_write(pipe, complete_buffer,
-	    complete_buffer_size);
+	const errno_t ret_val = usb_pipe_write(ath_usb->output_data_pipe,
+	    complete_buffer, complete_buffer_size);
 	
 	free(complete_buffer);
@@ -173,7 +180,4 @@
 {
 	ath_usb_t *ath_usb = (ath_usb_t *) ath->specific_data;
-	usb_pipe_t *pipe = &usb_device_get_mapped_ep(
-	    ath_usb->usb_device, ath_usb->input_data_pipe_number)->pipe;
-	
-	return usb_pipe_read(pipe, buffer, buffer_size, transferred_size);
+	return usb_pipe_read(ath_usb->input_data_pipe, buffer, buffer_size, transferred_size);
 }
Index: uspace/drv/nic/ar9271/ath_usb.h
===================================================================
--- uspace/drv/nic/ar9271/ath_usb.h	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/nic/ar9271/ath_usb.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -45,8 +45,8 @@
 typedef struct {
 	/** USB pipes indexes */
-	int input_ctrl_pipe_number;
-	int output_ctrl_pipe_number;
-	int input_data_pipe_number;
-	int output_data_pipe_number;
+	usb_pipe_t *input_ctrl_pipe;
+	usb_pipe_t *output_ctrl_pipe;
+	usb_pipe_t *input_data_pipe;
+	usb_pipe_t *output_data_pipe;
 	
 	/** Pointer to connected USB device. */
@@ -59,5 +59,5 @@
 } ath_usb_data_header_t;
 
-extern errno_t ath_usb_init(ath_t *, usb_device_t *);
+extern errno_t ath_usb_init(ath_t *, usb_device_t *, const usb_endpoint_description_t **endpoints);
 
 #endif  /* ATHEROS_ATH_USB_H */
Index: uspace/lib/c/include/bitops.h
===================================================================
--- uspace/lib/c/include/bitops.h	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/lib/c/include/bitops.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -54,4 +54,8 @@
 #define BIT_RANGE_EXTRACT(type, hi, lo, value) \
     (((value) >> (lo)) & BIT_RRANGE(type, (hi) - (lo) + 1))
+
+/** Insert @a value between bits @a hi .. @a lo. */
+#define BIT_RANGE_INSERT(type, hi, lo, value) \
+    (((value) & BIT_RRANGE(type, (hi) - (lo) + 1)) << (lo))
 
 /** Return position of first non-zero bit from left (i.e. [log_2(arg)]).
Index: uspace/lib/c/include/byteorder.h
===================================================================
--- uspace/lib/c/include/byteorder.h	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/lib/c/include/byteorder.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -85,4 +85,9 @@
 #define ntohl(n)  uint32_t_be2host((n))
 
+#define uint8_t_be2host(n)  (n)
+#define uint8_t_le2host(n)  (n)
+#define host2uint8_t_be(n)  (n)
+#define host2uint8_t_le(n)  (n)
+
 static inline uint64_t uint64_t_byteorder_swap(uint64_t n)
 {
Index: uspace/lib/c/include/ipc/dev_iface.h
===================================================================
--- uspace/lib/c/include/ipc/dev_iface.h	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/lib/c/include/ipc/dev_iface.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -44,11 +44,11 @@
 	/** Audio device pcm buffer interface */
 	AUDIO_PCM_BUFFER_IFACE,
-	
+
 	/** Network interface controller interface */
 	NIC_DEV_IFACE,
-		
+
 	/** IEEE 802.11 interface controller interface */
 	IEEE80211_DEV_IFACE,
-	
+
 	/** Interface provided by any PCI device. */
 	PCI_DEV_IFACE,
@@ -56,5 +56,7 @@
 	/** Interface provided by any USB device. */
 	USB_DEV_IFACE,
-	/** Interface provided by USB host controller. */
+	/** Interface provided by USB diagnostic devices. */
+	USBDIAG_DEV_IFACE,
+	/** Interface provided by USB host controller to USB device. */
 	USBHC_DEV_IFACE,
 	/** Interface provided by USB HID devices. */
Index: uspace/lib/drv/Makefile
===================================================================
--- uspace/lib/drv/Makefile	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/lib/drv/Makefile	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -47,4 +47,5 @@
 	generic/remote_usb.c \
 	generic/remote_pci.c \
+	generic/remote_usbdiag.c \
 	generic/remote_usbhc.c \
 	generic/remote_usbhid.c \
Index: uspace/lib/drv/generic/dev_iface.c
===================================================================
--- uspace/lib/drv/generic/dev_iface.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/lib/drv/generic/dev_iface.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -48,4 +48,5 @@
 #include "remote_ieee80211.h"
 #include "remote_usb.h"
+#include "remote_usbdiag.h"
 #include "remote_usbhc.h"
 #include "remote_usbhid.h"
@@ -65,4 +66,5 @@
 		[PCI_DEV_IFACE] = &remote_pci_iface,
 		[USB_DEV_IFACE] = &remote_usb_iface,
+		[USBDIAG_DEV_IFACE] = &remote_usbdiag_iface,
 		[USBHC_DEV_IFACE] = &remote_usbhc_iface,
 		[USBHID_DEV_IFACE] = &remote_usbhid_iface,
@@ -85,5 +87,5 @@
 	if (iface_method_idx >= rem_iface->method_count)
 		return NULL;
-	
+
 	return rem_iface->methods[iface_method_idx];
 }
Index: uspace/lib/drv/generic/private/remote_usbdiag.h
===================================================================
--- uspace/lib/drv/generic/private/remote_usbdiag.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/lib/drv/generic/private/remote_usbdiag.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,44 @@
+/*
+ * Copyright (c) 2017 Petr Manek
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdrv
+* @{
+*/
+/** @file
+*/
+
+#ifndef LIBDRV_REMOTE_USBDIAG_H_
+#define LIBDRV_REMOTE_USBDIAG_H_
+
+extern remote_iface_t remote_usbdiag_iface;
+
+#endif
+
+/**
+* @}
+*/
Index: uspace/lib/drv/generic/private/remote_usbhc.h
===================================================================
--- uspace/lib/drv/generic/private/remote_usbhc.h	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/lib/drv/generic/private/remote_usbhc.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2010 Vojtech Horky
+ * Copyright (c) 2017 Ondrej Hlavaty
  * All rights reserved.
  *
